#!/usr/bin/env python

import socket
import rospy
import sys
import string
from std_msgs.msg import Float32
from aqs_node.msg import THD

node_name = sys.argv[1] if len(sys.argv) > 1 else "unknown_node"
rospy.init_node('thd_ros_adapter', anonymous=True)
thd_pub = rospy.Publisher(node_name + "/thd", THD, queue_size=10)

UDP_IP = "";
### CONSTS
if string.find(node_name, "5") != -1:
  print "Running node for N5"
  UDP_IP = '192.168.1.105'
else:
  print "Running node for N9"
  UDP_IP = '192.168.1.120'

thd_msg = THD()

UDP_PORT = 55005
BUFFER_SIZE = 1024
MESSAGE = "reqData"
rate = rospy.Rate(0.1); # 6 Hz

while not rospy.is_shutdown():
  now=int(rospy.Time.now().to_sec())
  s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
  s.settimeout(5)
  # Send message
  s.sendto(MESSAGE, (UDP_IP, UDP_PORT))
  try:
    # Try to read
    data = s.recv(BUFFER_SIZE)
    data = data.split(";")
    print data
    # Avoid "out of bounds"
    if len(data) >= 5:
      thd_msg.temperature = float(data[2])/10.0
      thd_msg.humidity = float(data[3])/10.0
      thd_msg.dust = float(data[4])
      thd_msg.header.frame_id = node_name + "_sensor_frame"
      thd_msg.header.stamp = rospy.Time.now();
      thd_pub.publish(thd_msg)
  except Exception as e:
    print "Error: ", e
  s.close()
  rate.sleep()

  
