#ifndef DATA_TYPES_H
#define DATA_TYPES_H

#include <glm/glm.hpp>
#include <array>

#include <oct.h>
#include <ov-re-mat.h>
namespace thd_mapping {

    using Reading = glm::vec3;
    
//    using Position = glm::vec2;

    class Position : public glm::vec2
    {
    public:
        Position () = default;
        // Position(int x, int y) : glm::vec2(x, y) {};
        // Position(double x, double y) : glm::vec2(x, y) {};
         Position(float x, float y) : glm::vec2(x, y) {};
        Position(glm::vec2 rhs)
        {
            this->x = rhs.x;
            this->y = rhs.y;
        }
        operator glm::vec2& ()
        {
            return (glm::vec2&) *this;
        }
        operator glm::vec2 ()
        {
            return (glm::vec2) *this;
        }
        Position(Matrix && rhs)
        {
            x = rhs(0,1) - 1;
            y = rhs(0,0) - 1;
        }
    };
    
        

using Indices = glm::vec2;

/**
 * Templated DataPoint struct.
 * All algorithms must operate on this data type.
 */
    struct DataPoint {
        int node_id;
        int64_t time;
        float data;
        Position position;
    };


};

#endif // DATA_TYPES_H
