#pragma once
#include <thd_mapping/gdm_algorithm.h>
#include <thd_mapping/kernel.h>
#include <boost/shared_ptr.hpp>


namespace thd_mapping {

    THD_MAPPING_CLASS_FORWARD(GaussianKernelWeightMapper)

    class GaussianKernelWeightMapper : public GDMAlgorithm
    {
        typedef std::vector <float> Kernel;
        Kernel mKernel;
        int mKernelSize;
    public:

        GaussianKernelWeightMapper(GridMap && grid, int kernelSize);

        virtual void addDataPoint(const DataPoint& dataPoint);

        virtual void addDataPoints(const std::vector<DataPoint>& dataPoints);

        virtual ~GaussianKernelWeightMapper();

    };

}
