#ifndef GDM_ALGORITHM_H
#define GDM_ALGORITHM_H

#include <thd_mapping/grid_map.h>
#include <thd_mapping/data_types.h>
#include <thd_mapping/class_forward.h>


namespace thd_mapping {

THD_MAPPING_CLASS_FORWARD(GDMAlgorithm)

class GDMAlgorithm {

protected:
    GridMap mGrid;
    GridMap _varianceMap;

  public:
    GDMAlgorithm(GridMap && grid);

    const GridMap& getMap() const;
    GridMap getVarianceMap() const;

    virtual void addDataPoint(const DataPoint& dataPoint) = 0;
    virtual void addDataPoints(const std::vector<DataPoint>& dataPoints) = 0;
    virtual ~GDMAlgorithm() = 0;

    
    
};



}

#endif // GDM_ALGORITHM_H
