#pragma once

#include <thd_mapping/gdm_algorithm.h>
#include <thd_mapping/oct_runner.hpp>
#include <nav_msgs/OccupancyGrid.h>
#include <ros/ros.h>
#include <boost/shared_ptr.hpp>
#include <thd_mapping/index.hpp>
namespace thd_mapping {
    
    THD_MAPPING_CLASS_FORWARD(GaussianRandomFieldAlgorithm)

    class GaussianRandomFieldAlgorithm : public GDMAlgorithm
    {
    public:
        GaussianRandomFieldAlgorithm(GridMap && grid);

        void addDataPoint(const DataPoint& dataPoint);
        void addDataPoints(const std::vector<DataPoint>& dataPoints);
        void occupancyCallback(const nav_msgs::OccupancyGrid::ConstPtr&);
        void setOccupancyMap(thd_mapping::GridMap);

        void setDelay(int delay) {
            _delay = delay;
        }

        const GridMap& getCovarianceMap() const {
            return _varianceMap;
        }
        
    protected:
        thd_mapping::GridMap _occupancyMap;
    private:
        void run();
        
        ros::Subscriber _occupancySub;
        int _delay;
        int _previous;
        std::map<int, DataPoint> _readings;

        
    };

}
