#pragma once
#include <thd_mapping/gdm_algorithm.h>
#include "thd_mapping/grid_map.h"

namespace thd_mapping
{

class LearnedWeights : public GDMAlgorithm
{
    std::vector<GridMap> mWeights;
    std::vector<DataPoint> mSensorDataPoints;
    DataPoint mMobileDataPoint;
    bool mHasNewData = false;

    // int _numSensors;

    std::vector <float> mKernel;
    int mKernelSize;


  public:
    LearnedWeights(GridMap &&grid, std::vector<DataPoint> sensorDataPoints, int kernelSize);

    virtual void addDataPoint(const DataPoint &dataPoint);
    virtual void addDataPoints(const std::vector<DataPoint> &dataPoints);
    void updateMap();

    virtual ~LearnedWeights() {}
};
}
