#pragma once
#include "basic_node.h"
#include <string>
#include <aqs_node/THD.h>
#include <ros/ros.h>
#include <boost/function.hpp>
#include <vector>
namespace thd_mapping {
    
    THD_MAPPING_CLASS_FORWARD(MedianNode);
    class MedianNode : public BasicNode {
    public:
        MedianNode(std::string, int);
        MedianNode(std::string, boost::function<void(const SensorNode&)>, int);
        MedianNode(std::string, Position, int);
        MedianNode(std::string, Position, boost::function<void(const SensorNode&)>, int);
        ~MedianNode() = default;

    private:
        void thdCallback(const aqs_node::THD::ConstPtr& msg);
        std::vector<double> mListTemperatures;
        std::vector<double> mListHumidity;
        std::vector<double> mListDust;
        const int mWindow;
    };
}
