#pragma once
#include "basic_node.h"
#include <string>
#include <aqs_node/THD.h>
#include <ros/ros.h>
#include <boost/function.hpp>

namespace thd_mapping {
    
    THD_MAPPING_CLASS_FORWARD(SmoothingNode);
    class SmoothingNode : public BasicNode {
    public:
        SmoothingNode(std::string, double);
        SmoothingNode(std::string, boost::function<void(const SensorNode&)>, double);
        SmoothingNode(std::string, Position, double);
        SmoothingNode(std::string, Position, boost::function<void(const SensorNode&)>, double);
        virtual ~SmoothingNode() = default;
    private:
        void thdCallback(const aqs_node::THD::ConstPtr& msg) override;
        double mAlpha;
    };
}
