#include "ros/ros.h"
#include "ros/time.h"
#include <string>
#include <aqs_node/THD.h>
#include <glm/glm.hpp>
#include <glm/gtc/constants.hpp>


std::vector<ros::Publisher> sensorNodePubs(3);

void publishFake(ros::Publisher pub,float temp, float hum, float dust)
{
      aqs_node::THD thd_msg;
      thd_msg.temperature = temp;
      thd_msg.humidity = hum;
      thd_msg.dust = dust;
      thd_msg.header.stamp = ros::Time::now();
      thd_msg.header.frame_id = "map";
			
      pub.publish(thd_msg);
}

int main(int argc, char *argv[])
{
    ros::init(argc, argv, "fake_sensor_data");
    
    ros::NodeHandle n;
    ros::Rate r(1);


    sensorNodePubs[0] = n.advertise<aqs_node::THD>("n5/thd", 1000);
    sensorNodePubs[1] = n.advertise<aqs_node::THD>("n9/thd", 1000);
    sensorNodePubs[2] = n.advertise<aqs_node::THD>("usb/thd", 1000);


    while (n.ok())
    {
        ros::spinOnce();

        float timeNow = ros::Time::now().toSec();
        // for(auto& pub : sensorNodePubs)
        // {
        publishFake(sensorNodePubs[0],glm::sin(timeNow/20.0f * glm::pi<float>())* 5 + 15,21,10);
        publishFake(sensorNodePubs[1],glm::sin((timeNow/20.0f + 2.0f) * glm::pi<float>())* 7 + 15,21,10);
        publishFake(sensorNodePubs[2],glm::sin(timeNow/20.0f * glm::pi<float>())* 5 + 15,21,10);
        // publishFake(sensorNodePubs[0],10,21,10);
        // publishFake(sensorNodePubs[1],20,21,10);
        // publishFake(sensorNodePubs[2],16,21,10);
        // }
        r.sleep();
    }

}