#include <thd_mapping/gdm_algorithm.h>
#include <thd_mapping/index.hpp>
namespace thd_mapping {

    GDMAlgorithm::GDMAlgorithm(GridMap && grid) : mGrid(grid) {}

    const GridMap& GDMAlgorithm::getMap() const
    {
	return mGrid;
    }

    GDMAlgorithm::~GDMAlgorithm() = default;

    GridMap GDMAlgorithm::getVarianceMap() const {
        if (_varianceMap._cov)
        {
            int maxrows, maxcols;
            std::vector<float> _new;
            _new.reserve(_varianceMap.dim.y*_varianceMap.dim.x);
            maxrows = maxcols =_varianceMap.dim.y*_varianceMap.dim.x;
            thd_mapping::Index index(maxcols, maxrows);
            for (octave_idx_type row = 0; row < maxrows; row++)
            {
                for (octave_idx_type col = 0; col < maxcols; col++)
                {
                    if (row == col)
                        _new.push_back(_varianceMap.grid[index(col,row)]);
                }
            }
            return thd_mapping::GridMap(std::move(_new), _varianceMap.dim, _varianceMap.origin, _varianceMap.resolution);
        }
        else
        {
            return _varianceMap;
        }
    }
}
