#include <thd_mapping/max_variance_goal_finder.hpp>
#include "ros/package.h"
namespace thd_mapping
{
    // MaxVarianceGoalFinder::MaxVarianceGoalFinder (const thd_mapping::GridMap& grid, const thd_mapping::GridMap &  occupancy) : GoalFindingAlgorithm(grid, occupancy)
    // {
    //     //noop
    // }
    MaxVarianceGoalFinder::~MaxVarianceGoalFinder()
    {
        // nothing to destruct
    }

    const Position MaxVarianceGoalFinder::getGoal(const GridMap& grid, const GridMap& occupancy)
    {
        std::string packagePath = ros::package::getPath("thd_mapping");
        thd_mapping::OctRunner::getInstance().prepare("exploreMaxVariance", packagePath + "/../matlab");

        thd_mapping::OctRunner::getInstance().setParams({
                {"occupancyThreshold", 0}
            });
        thd_mapping::OctRunner::getInstance().call(grid, occupancy,  _position, grid.dim);
        Indices _pos = thd_mapping::OctRunner::getInstance().getResult<Position>(0);

        printf("Goal Pos%f:%f\n",_pos.x,_pos.y);

        _pos = grid.toPosition(_pos);
        thd_mapping::OctRunner::getInstance().done("..");
        return _pos;
    }
}
