#include "thd_mapping/smoothing_node.hpp"


namespace thd_mapping {
    SmoothingNode::SmoothingNode (std::string pName, double pAlpha) : SmoothingNode(pName, Position(0,0), NULL, pAlpha)
    { /*noop*/ }

    SmoothingNode::SmoothingNode(std::string pName,
                                 boost::function<void(const SensorNode&)> pCallback, double pAlpha )  : SmoothingNode(pName, Position(0,0), pCallback, pAlpha)
    { /* noop */ }

    SmoothingNode::SmoothingNode(std::string pName, Position pPos, double pAlpha) : SmoothingNode(pName, pPos, NULL, pAlpha)
    { /* noop */ }

    SmoothingNode::SmoothingNode(std::string pName,
                                 Position pPos,
                                 boost::function<void(const SensorNode&)> pCallback, 
                                 double pAlpha) : BasicNode(pName, pPos, pCallback), mAlpha(pAlpha)
    {
        // if (ros::isInitialized())
        // {
        //     ros::NodeHandle nh(pName);
        //     this->mSubThd = nh.subscribe("thd", 10, &SmoothingNode::thdCallback, this);
        //     this->mSubPos = nh.subscribe("pos", 10, &SmoothingNode::posCallback, dynamic_cast<BasicNode*>(this));
        // }
    }

    void SmoothingNode::thdCallback(const aqs_node::THD::ConstPtr& msg)
    {
        this->mReading = Reading(mReading.x * mAlpha + (1-mAlpha)*msg->temperature,
                                 mReading.y * mAlpha + (1-mAlpha)*msg->humidity,
                                 mReading.z * mAlpha + (1-mAlpha)*msg->dust);
        if (mCallback && _hasPosition)
            mCallback(*this);
    }
}
