#include <thd_mapping/static_node.h>


namespace thd_mapping {


StaticNode::StaticNode(const std::string& pName, const Position& pPos) : mName(pName), mPosition(pPos)
{
    ros::NodeHandle nh(pName);
    this->mSubscriber = nh.subscribe("thd", 10, &StaticNode::thdCallback, this);
}

StaticNode::StaticNode(const std::string& pName, const Position& pPos, boost::function<void(const SensorNode&)> callback_fn )  : mName(pName), mPosition(pPos), mCallback(callback_fn)
{
    ros::NodeHandle nh(pName);
    this->mSubscriber = nh.subscribe("thd", 10, &StaticNode::thdCallback, this);
}

void StaticNode::thdCallback(const aqs_node::THD::ConstPtr& msg)
{
    this->mReading = Reading(msg->temperature, msg->humidity, msg->dust);
    mCallback(*this);
}

Position StaticNode::getPosition() const {
    return mPosition;
}

Reading StaticNode::getReading() const {
    return mReading;
}

}
