OccupancyGridView = function (options) {
    options = options || {};

    this.alpha = options.alpha || 1.0;
    this.canvas2 = document.createElement("canvas");
    this.oldwidth = 0;
    this.oldheight = 0;
    this.hidden = options.hidden || false;

    this.draw = function (context, offset, scale) {
        if (!this.message || this.hidden)
            return

        this.width = this.message.info.width;
        this.height = this.message.info.height;
        this.scaleX = this.message.info.resolution;
        this.scaleY = this.message.info.resolution;

        if(this.width != this.oldwidth || this.height != this.oldheight)
        {
            this.imageData = context.createImageData(this.width, this.height);
            this.oldwidth = this.width;
            this.oldheight = this.height;
        }

        this.x = this.message.info.origin.position.x;
        this.y = -this.message.info.origin.position.y - this.height * this.message.info.resolution;

        // var canvas2 = document.createElement("canvas");
        this.canvas2.width = this.width;
        this.canvas2.height = this.height;
        var ctx2 = this.canvas2.getContext("2d");


        for (var row = 0; row < this.height; row++) {
            for (var col = 0; col < this.width; col++) {
                // determine the index into the map data
                var mapI = col + ((this.height - row - 1) * this.width);

                // determine the value
                var data = this.message.data[mapI];
                var val = data;
                if (data > 50) {
                    val = 0;
                } else if (data >= 0) {
                    val = 255;
                } else {
                    val = 127;
                }
                let alpha = val === 255 ? 0 : 255

                // determine the index into the image data array
                var i = (col + (row * this.width)) * 4;
                // r
                this.imageData.data[i] = val;
                // g
                this.imageData.data[++i] = val;
                // b
                this.imageData.data[++i] = val;
                // a
                this.imageData.data[++i] = alpha ;
            }
        }
        ctx2.putImageData(this.imageData, 0, 0);

        context.drawImage(this.canvas2,
            offset.x + this.x / this.scaleX * scale,
            offset.y + this.y / this.scaleY * scale,
            this.canvas2.width * scale,
            this.canvas2.height * scale
        );
    }
};