
#import pprint
import sqlite3
import csv
import sys

dbName = "try3.db"
if len(sys.argv) > 1:
    dbName = sys.argv[1]

csvName = "output2.csv"
if len(sys.argv) > 2:
    csvName = sys.argv[2]

print("DB name",dbName,"CSV name",csvName)
conn = sqlite3.connect(dbName)
c = conn.cursor()

result = c.execute('''select m1.time,n1.name,m1.temp,m1.humidity,n2.name,m2.temp,m2.humidity,n3.name,m3.temp,m3.humidity
                        FROM measurement AS m1 
                        JOIN measurement AS m2 ON m1.node_id = 1 AND m2.node_id = 2 AND m1.time = m2.time 
                        JOIN measurement AS m3 ON m1.node_id = 1 AND m2.node_id = 2 AND m3.node_id = 3 AND m1.time = m3.time
                        INNER JOIN node AS n1 ON n1.ID = m1.node_id
                        INNER JOIN node AS n2 ON n2.ID = m2.node_id
                        INNER JOIN node AS n3 ON n3.ID = m3.node_id
                        ''');

data = result.fetchall()

dataHeader = ["Time","Name1","Temp1","Humidity1","Name2","Temp2","Humidity2","Name3","Temp3","Humidity3"]

with open(csvName, 'wb') as csvfile:
    dataWriter = csv.writer(csvfile)
    #dataWriter.writeheader()
    dataWriter.writerow(dataHeader)
    dataWriter.writerows(data)


print("points", len(data));